#include "libraryloader.h"

Libraryloader::Libraryloader(const QString &name)
{
    pMPX=0;
    lib=0;
    LoadLibrary(name);
}

Libraryloader::Libraryloader()
{
    pMPX=0;
    lib=0;
}

Libraryloader::~Libraryloader()
{
    CloseLibrary();
}

JMPXInterface* Libraryloader::LoadLibrary(const QString &name)
{
    CloseLibrary();
#if defined(__linux__)
    // load the library
        lib = dlopen(name.toAscii().data(), RTLD_LAZY);
        if (!lib) {
            cerr << "Cannot load library: " << dlerror() << '\n';
            return 0;
        }
         else cerr << "library loaded\n";

    // load the symbols
        destroy_instance=0;
        create_instance=0;
        create_instance = (create_t*) dlsym(lib, "create");
        destroy_instance = (destroy_t*) dlsym(lib, "destroy");
        if (!create_instance || !destroy_instance) {
            cerr << "Cannot load symbols: " << dlerror() << '\n';
            // unload the library
            if(lib)dlclose(lib);
            lib=0;
            return 0;
        }
#else
    // load the library
        lib = ::LoadLibrary(name.toStdWString().data());
    if (!lib) {
        cerr << "Cannot load library:\n";
        return 0;
    }

    // load the symbols
        destroy_instance=0;
        create_instance=0;
        create_instance = (create_t*) GetProcAddress(lib, "create");
        destroy_instance = (destroy_t*) GetProcAddress(lib, "destroy");
        if (!create_instance || !destroy_instance) {
            cerr << "Cannot load symbols: \n";
            // unload the library
            if(lib)FreeLibrary(lib);
            lib=0;
            return 0;
        }
#endif
        // create an instance of the class
        pMPX = create_instance();

        return pMPX;
}

void Libraryloader::CloseLibrary()
{
    // destroy the class
    if(pMPX)
    {
        cerr << "library unloaded\n";
        destroy_instance(pMPX);
        pMPX=0;
    }
    // unload the library
    if(lib)
    {
#if defined(__linux__)
        dlclose(lib);
#else
        FreeLibrary(lib);
#endif
        lib=0;
    }
}
