#ifndef LIBRARYLOADER_H
#define LIBRARYLOADER_H

#include <string>
#include <iostream>
#ifdef __linux__
#include <dlfcn.h>
#else
#include <windows.h>
#endif
#include "JMPXInterface.h"
#include <QString>

class Libraryloader
{
public:
    Libraryloader(const QString &name);
    Libraryloader();
    ~Libraryloader();
    JMPXInterface* LoadLibrary(const QString &name);
    void CloseLibrary();
    JMPXInterface* pMPX;
private:
    #ifdef __linux__
    void* lib;
    #else
    HINSTANCE lib;
    #endif
    create_t* create_instance;
    destroy_t* destroy_instance;
};

#endif // LIBRARYLOADER_H
