//---------------------------------------------------------------------------

#ifndef JCSoundH
#define JCSoundH
//---------------------------------------------------------------------------

#include "Definitions.h"
#include "RtAudio.h"
#include <boost/bind.hpp>
#include <boost/function.hpp>

using namespace std;

typedef vector<short> ShortBuffer;

typedef boost::function < void (double *,double *, int) > TSoundIOEvent;

enum EnumSoundDir {sdirIn,sdirOut,sdirInOut};

//---------------------------------------------------------------------------
class TJCSound
{
public:
         TJCSound();
         ~TJCSound();

private:
        static int Dispatcher( void *outputBuffer, void *inputBuffer, unsigned int nBufferFrames, double streamTime, RtAudioStreamStatus status, void *userData )
        {
            TJCSound *pInstance=(TJCSound*)userData;
            if(pInstance->FOnSoundEvent)pInstance->FOnSoundEvent((double*)inputBuffer,(double*)outputBuffer,2*nBufferFrames);
            return 0;
        }
        vector<SDeviceInfo> Device;
        vector<RtAudio::DeviceInfo> RtAudioDevices;

public:
        void Active(bool State);
        bool IsActive();

        void PopulateDevices();
        SDevices Devices;

        RtAudio AnRtAudio;

        TSoundIOEvent FOnSoundEvent;


    	RtAudio::StreamParameters oParameters,iParameters;
    	unsigned int sampleRate;
    	unsigned int bufferFrames;

        RtAudio::StreamOptions options;

        string LastErrorMessage;
        bool GotError;


protected:


public:

protected:







};
//---------------------------------------------------------------------------






#endif
