//---------------------------------------------------------------------------

#ifndef TJQAMH
#define TJQAMH

#include <memory>
#include <math.h>
#include <vector>
#include <string>
#include <boost/bind.hpp>
#include <boost/function.hpp>

#if defined(__linux__)
#include <sys/time.h>
#include <sys/resource.h>
#include "semaphore.h"
#include <pthread.h>
#define MSSLEEP(x)	usleep(x*1000)
#else
#include <windows.h>
#define MSSLEEP(x)	Sleep(x)
#endif

#include <iostream>

#include <sstream>

#include "Definitions.h"


#define WTSIZE 8000
#define WTSIZE_1 7999

using namespace std;

class TDspGen
{
private:
        TSetGen *pSetGen;

public:

        void  ResetSettings();
         TDspGen(TSetGen *_pSetGen);
         ~TDspGen();

        vector<double> SinWT;

        double Freq;
        int SampleRate;
};



//------------------

class WaveTable
{
public:
         WaveTable(TDspGen *_pDspGen);

        ~WaveTable();
        void WTnextFrame();
        double   WTSinValue();
        double   WTSin2Value();
        void  RefreshSettings();
private:
        double WTstep;
        int intWTptr;
        double WTptr;
        TDspGen *pDspGen;
};

//-------------------

class PreEmphasis
{
private:
	double a[2];
	double b[2];
	double y[2];
	double x[2];
public:
	enum TimeConstant {WORLD,USA,NONE};
	PreEmphasis();
	void SetTc(TimeConstant timeconst);
	double Update(double val);
};

class Clipper
{
private:
	vector<double> LookupTable;
	double compressionpoint;
public:
	Clipper();
	double Update(double val);
	void SetCompressionPoint(double point);

};

class FIRFilter
{
private:
	vector<double> Buf;
	int BufPtr;
public:
	vector<double> Cof;
	FIRFilter();
	double Update(double val);
};



#endif
