#ifndef _JMPXENCODER_HPP
#define _JMPXENCODER_HPP

#include "JMPXInterface.h"
#include "JDSP.hpp"
#include "JCSound.hpp"
#include "fir/FIR.h"
#include "fir/Signals.h"


class JMPXEncoder : public JMPXInterface
{
public:
	JMPXEncoder();
    ~JMPXEncoder();

private:
    TJCSound AJCSound;
    TSetGen ASetGen;
    std::auto_ptr< TDspGen > pTDspGen;
    std::auto_ptr< WaveTable > pWaveTable;
    void Update(double *DataIn,double *DataOut, int Size);
    bool stereo;

    TSigStats sigstats;

    PreEmphasis lpreemp;
    PreEmphasis rpreemp;

    Clipper clipper;

    double lbigval;
    double rbigval;
    double outbigval;
    int decl;

public:

    void EnableStereo(bool enable);

    void Active(bool Enabled);
    bool IsActive(){return AJCSound.IsActive();};

    void SetSoundCard(unsigned int device){AJCSound.iParameters.deviceId=device;AJCSound.oParameters.deviceId=device;}
    void SetSampleRate(int sampleRate){AJCSound.sampleRate=sampleRate;};
    void SetBufferFrames(int bufferFrames){AJCSound.bufferFrames=bufferFrames;};

    void SetPreEmphasis(TimeConstant timeconst);

    bool GotError(){return AJCSound.GotError;}
    const char* GetLastRTAudioError(){AJCSound.GotError=false;return AJCSound.LastErrorMessage.data();}

    TSigStats* GetSignalStats();

    SDevices* GetDevices(void)
    {
    	return &AJCSound.Devices;
    }
};

#endif	/* _JMPXENCODER_HPP */

